## busybox-0.60.5.tar.bz2

=== Makefile ===
# Makefile for busybox
#
# Copyright (C) 1999-2002 Erik Andersen <andersee@debian.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

PROG      := busybox
VERSION   := 0.60.5
BUILDTIME := $(shell TZ=UTC date -u "+%Y.%m.%d-%H:%M%z")
export VERSION

# With a modern GNU make(1) (highly recommended, that's what all the
# developers use), all of the following configuration values can be
# overridden at the command line.  For example:
#   make CROSS=powerpc-linux- BB_SRC_DIR=$HOME/busybox PREFIX=/mnt/app

# If you want to add some simple compiler switches (like -march=i686),
# especially from the command line, use this instead of CFLAGS directly.
# For optimization overrides, it's better still to set OPTIMIZATION.
CFLAGS_EXTRA =
 
# If you want a static binary, turn this on.
DOSTATIC = false

# Set the following to `true' to make a debuggable build.
# Leave this set to `false' for production use.
DODEBUG = false

# Setting this to `true' will cause busybox to directly use the system's
# password and group functions.  Assuming you use GNU libc, when this is
# `true', you will need to install the /etc/nsswitch.conf configuration file
# and the required libnss_* libraries. This generally makes your embedded
# system quite a bit larger... If you leave this off, busybox will directly use
# the /etc/password, /etc/group files (and your system will be smaller, and I
# will get fewer emails asking about how glibc NSS works).  Enabling this adds
# just 1.4k to the binary size (which is a _lot_ less then glibc NSS costs).
# Note that if you want hostname resolution to work with glibc, you still need
# the libnss_* libraries.  
USE_SYSTEM_PWD_GRP = true

# This enables compiling with dmalloc ( http://dmalloc.com/ )
# which is an excellent public domain mem leak and malloc problem
# detector.  To enable dmalloc, before running busybox you will
# want to first set up your environment.
# eg: `export DMALLOC_OPTIONS=debug=0x34f47d83,inter=100,log=logfile`
# The debug= value is generated using the following command
# dmalloc -p log-stats -p log-non-free -p log-bad-space -p log-elapsed-time \
#      -p check-fence -p check-heap -p check-lists -p check-blank \
#      -p check-funcs -p realloc-copy -p allow-free-null
# Do not enable this for production builds...
DODMALLOC = false

# Electric-fence is another very useful malloc debugging library.
# Do not enable this for production builds...
DOEFENCE  = false

# If you want large file summit support, turn this on.
# This has no effect if you don't have a kernel with lfs
# support, and a system with libc-2.1.3 or later.
# Some of the programs that can benefit from lfs support
# are dd, gzip, mount, tar, and mkfs_minix.
# LFS allows you to use the above programs for files
# larger than 2GB!
DOLFS = false

# If you have a "pristine" source directory, point BB_SRC_DIR to it.
# Experimental and incomplete; tell the mailing list
# <busybox@busybox.net> if you do or don't like it so far.
BB_SRC_DIR =

# If you are running a cross compiler, you may want to set this
# to something more interesting, like "powerpc-linux-".
CROSS =
CC = $(CROSS)gcc
AR = $(CROSS)ar
STRIP = $(CROSS)strip

# To compile vs uClibc, just use the compiler wrapper built by uClibc...
# Everything should compile and work as expected these days...
#CC=/usr/i386-linux-uclibc/bin/i386-uclibc-gcc

# To compile vs some other alternative libc, you may need to use/adjust
# the following lines to meet your needs...
#
# If you are using Red Hat 6.x with the compatible RPMs (for developing under
# Red Hat 5.x and glibc 2.0) uncomment the following.  Be sure to read about
# using the compatible RPMs (compat-*) at http://www.redhat.com !
#LIBCDIR=/usr/i386-glibc20-linux
#
# The following is used for libc5 (if you install altgcc and libc5-altdev
# on a Debian system).  
#LIBCDIR=/usr/i486-linuxlibc1
#
# For other libraries, you are on your own...
#LDFLAGS+=-nostdlib
#LIBRARIES = $(LIBCDIR)/lib/libc.a -lgcc
#CROSS_CFLAGS+=-nostdinc -I$(LIBCDIR)/include -I$(GCCINCDIR)
#GCCINCDIR = $(shell gcc -print-search-dirs | sed -ne "s/install: \(.*\)/\1include/gp")

WARNINGS = -Wall -Wshadow

ARFLAGS = -r


TARGET_ARCH:=${shell $(CC) -dumpmachine | sed -e s'/-.*//' \
		-e 's/i.86/i386/' \
		-e 's/sparc.*/sparc/' \
		-e 's/arm.*/arm/g' \
		-e 's/m68k.*/m68k/' \
		-e 's/ppc/powerpc/g' \
		-e 's/v850.*/v850/g' \
		-e 's/sh[234]/sh/' \
		-e 's/mips.*/mips/' \
		}

#--------------------------------------------------------
# Arch specific compiler optimization stuff should go here.
# Unless you want to override the defaults, do not set anything
# for OPTIMIZATION...

# use '-Os' optimization if available, else use -O2
OPTIMIZATION := ${shell if $(CC) -Os -S -o /dev/null -xc /dev/null >/dev/null 2>&1; \
	then echo "-Os"; else echo "-O2" ; fi}

# Some nice architecture specific optimizations
ifeq ($(strip $(TARGET_ARCH)),arm)
	OPTIMIZATION+=-fstrict-aliasing
endif
ifeq ($(strip $(TARGET_ARCH)),i386)
	OPTIMIZATION+=-march=i386
	OPTIMIZATION+=${shell if $(CC) -mpreferred-stack-boundary=2 -S -o /dev/null -xc \
		/dev/null >/dev/null 2>&1; then echo "-mpreferred-stack-boundary=2"; fi}
	OPTIMIZATION+=${shell if $(CC) -falign-functions=1 -falign-jumps=0 -falign-loops=0 \
		-S -o /dev/null -xc /dev/null >/dev/null 2>&1; then echo \
		"-falign-functions=1 -falign-jumps=0 -falign-loops=0"; else \
		if $(CC) -malign-functions=0 -malign-jumps=0 -S -o /dev/null -xc \
		/dev/null >/dev/null 2>&1; then echo "-malign-functions=0 -malign-jumps=0"; fi; fi}
endif
OPTIMIZATIONS:=$(OPTIMIZATION) -fomit-frame-pointer


#--------------------------------------------------------
# If you're going to do a lot of builds with a non-vanilla configuration,
# it makes sense to adjust parameters above, so you can type "make"
# by itself, instead of following it by the same half-dozen overrides
# every time.  The stuff below, on the other hand, is probably less
# prone to casual user adjustment.
# 
ifeq ($(strip $(DOLFS)),true)
    # For large file support
    CFLAGS+=-D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
endif
ifeq ($(strip $(DODMALLOC)),true)
    # For testing mem leaks with dmalloc
    CFLAGS+=-DDMALLOC
    LIBRARIES = -ldmalloc
    # Force debug=true, since this is useless when not debugging...
    DODEBUG = true
else
    ifeq ($(strip $(DOEFENCE)),true)
	LIBRARIES = -lefence
	# Force debug=true, since this is useless when not debugging...
	DODEBUG = true
    endif
endif
ifeq ($(strip $(DODEBUG)),true)
    CFLAGS  += $(WARNINGS) -g -D_GNU_SOURCE
    LDFLAGS += -Wl,-warn-common
    STRIPCMD    = /bin/true -Since_we_are_debugging
else
    CFLAGS  += $(WARNINGS) $(OPTIMIZATIONS) -D_GNU_SOURCE
    LDFLAGS += -s -Wl,-warn-common
    STRIPCMD    = $(STRIP) -s --remove-section=.note --remove-section=.comment
endif
ifeq ($(strip $(DOSTATIC)),true)
    LDFLAGS += --static
    #
    #use '-ffunction-sections -fdata-sections' and '--gc-sections' (if they 
    # work) to try and strip out any unused junk.  Doesn't do much for me, 
    # but you may want to give it a shot...
    #
    #ifeq ($(shell $(CC) -ffunction-sections -fdata-sections -S \
    #	-o /dev/null -xc /dev/null 2>/dev/null && $(LD) \
    #			--gc-sections -v >/dev/null && echo 1),1)
    #	CFLAGS += -ffunction-sections -fdata-sections
    #	LDFLAGS += --gc-sections
    #endif
endif

ifeq ($(strip $(PREFIX)),)
    PREFIX = `pwd`/_install
endif

# Additional complications due to support for pristine source dir.
# Include files in the build directory should take precedence over
# the copy in BB_SRC_DIR, both during the compilation phase and the
# shell script that finds the list of object files.
# Work in progress by <ldoolitt@recycle.lbl.gov>.
#
ifneq ($(strip $(BB_SRC_DIR)),)
    VPATH = $(BB_SRC_DIR)
endif
#ifneq ($(strip $(VPATH)),)
#    CFLAGS += -I- -I. $(patsubst %,-I%,$(subst :, ,$(VPATH)))
#endif

# We need to set APPLET_SOURCES to something like
#   $(shell busybox.sh Config.h)
# but in a manner that works with VPATH and BB_SRC_DIR.
# Possible ways to approach this:
#
#   1. Explicitly search through .:$(VPATH) for busybox.sh and config.h,
#      then $(shell $(BUSYBOX_SH) $(CONFIG_H) $(BB_SRC_DIR))
#
#   2. Explicity search through .:$(VPATH) for slist.mk,
#      then $(shell $(MAKE) -f $(SLIST_MK) VPATH=$(VPATH) BB_SRC_DIR=$(BB_SRC_DIR))
#
#   3. Create slist.mk in this directory, with commands embedded in
#      a $(shell ...) command, and $(MAKE) it immediately.
#
#   4. Use a real rule within this makefile to create a file that sets 
#      APPLET_SOURCE_LIST, then include that file.  Has complications
#      with the first trip through the makefile (before processing the
#      include) trying to do too much, and a spurious warning the first
#      time make is run.
#
# This is option 3:
#
#APPLET_SOURCES = $(shell \
#   echo -e 'all: busybox.sh Config.h\n\t@ $$(SHELL) $$^ $$(BB_SRC_DIR)' >slist.mk; \
#   make -f slist.mk VPATH=$(VPATH) BB_SRC_DIR=$(BB_SRC_DIR) \
#)
# And option 4:
-include applet_source_list

OBJECTS   = $(APPLET_SOURCES:.c=.o) busybox.o usage.o applets.o
CFLAGS    += $(CROSS_CFLAGS)
CFLAGS    += -DBB_VER='"$(VERSION)"'
CFLAGS    += -DBB_BT='"$(BUILDTIME)"'
ifdef BB_INIT_SCRIPT
    CFLAGS += -DINIT_SCRIPT='"$(BB_INIT_SCRIPT)"'
endif

ifneq ($(strip $(USE_SYSTEM_PWD_GRP)),true)
    PWD_GRP	= pwd_grp
    PWD_GRP_DIR = $(BB_SRC_DIR:=/)$(PWD_GRP)
    PWD_LIB     = libpwd.a
    PWD_CSRC=__getpwent.c pwent.c getpwnam.c getpwuid.c putpwent.c getpw.c \
	    fgetpwent.c __getgrent.c grent.c getgrnam.c getgrgid.c fgetgrent.c \
	    initgroups.c setgroups.c
    PWD_OBJS=$(patsubst %.c,$(PWD_GRP)/%.o, $(PWD_CSRC))
ifneq ($(strip $(BB_SRC_DIR)),)
    PWD_CFLAGS = -I- -I.
endif
    PWD_CFLAGS += -I$(PWD_GRP_DIR)
else
    CFLAGS    += -DUSE_SYSTEM_PWD_GRP
endif
    
LIBBB	  = libbb
LIBBB_LIB = libbb.a
LIBBB_CSRC= ask_confirmation.c chomp.c concat_path_file.c copy_file.c \
copy_file_chunk.c libc5.c device_open.c error_msg.c inode_hash.c \
error_msg_and_die.c fgets_str.c find_mount_point.c find_pid_by_name.c \
find_root_device.c full_read.c full_write.c get_console.c \
get_last_path_component.c get_line_from_file.c gz_open.c human_readable.c \
isdirectory.c kernel_version.c loop.c mode_string.c module_syscalls.c mtab.c \
mtab_file.c my_getgrnam.c my_getgrgid.c my_getpwnam.c my_getpwnamegid.c \
my_getpwuid.c parse_mode.c parse_number.c perror_msg.c perror_msg_and_die.c \
print_file.c process_escape_sequence.c read_package_field.c recursive_action.c \
safe_read.c safe_strncpy.c syscalls.c syslog_msg_with_name.c time_string.c \
trim.c unzip.c vdprintf.c verror_msg.c vperror_msg.c wfopen.c xfuncs.c \
xgetcwd.c xreadlink.c xregcomp.c interface.c remove_file.c last_char_is.c \
copyfd.c vherror_msg.c herror_msg.c herror_msg_and_die.c xgethostbyname.c \
dirname.c make_directory.c create_icmp_socket.c u_signal_names.c arith.c \
simplify_path.c
LIBBB_OBJS=$(patsubst %.c,$(LIBBB)/%.o, $(LIBBB_CSRC))
ifeq ($(strip $(BB_SRC_DIR)),)
    LIBBB_CFLAGS += -I$(LIBBB)
else
    LIBBB_CFLAGS = -I- -I. -I./$(LIBBB) -I$(BB_SRC_DIR)/$(LIBBB) -I$(BB_SRC_DIR)
endif

LIBBB_MSRC=libbb/messages.c
LIBBB_MESSAGES= full_version name_too_long omitting_directory not_a_directory \
memory_exhausted invalid_date invalid_option io_error dash_dash_help \
write_error too_few_args name_longer_than_foo unknown can_not_create_raw_socket

=== debian/changelog ===
busybox (1:0.60.5-1) unstable; urgency=low
  
  * New version released.  See Changelog for non-Debian specific details.
  * zcat no longer tries to delete source files (closes: #164968)
  * Eliminate /linuxrc from the .udeb (closes: #163890)
  * Fix description of the --install option (closes: #164178)

 -- Erik Andersen <andersee@debian.org>  Sat, 26 Oct 2002 06:23:51 -0600

busybox (1:0.60.4-1.1) unstable; urgency=low

  * NMU
  * Fix cp -a so it handles symlinks properly (closes: #163501)

 -- Tollef Fog Heen <tfheen@debian.org>  Sun,  6 Oct 2002 16:08:45 +0200

busybox (1:0.60.4-1) unstable; urgency=low
  
  * New version released.  See Changelog for non-Debian specific details.
  * enable uname for the debian-installer (closes: #158706)
  * enable losetup for the boot floppies (closes: #138060)
  * init behaves itself better consoles go missing (closes: #129626)
  * In 'free', buffers change as buffered data increases (closes: #148396)
  * Functions for debootstrap added to the .udeb (closes: #124388)
  * This bug is not reproducable (closes: #127522)

 -- Erik Andersen <andersee@debian.org>  Wed, 18 Sep 2002 14:13:05 -0600

busybox (1:0.60.3-1) unstable; urgency=low
  
  * New version released.  See Changelog for non-Debian specific details.
  * makedevs no longer segfaults (closes: #123921)
  * wget no longer crashes (closes: #138943)
  * wget now checks the safe_fwrite return code (closes: #143179)

 -- Erik Andersen <andersee@debian.org>  Sat, 27 Apr 2002 01:33:34 -0600

busybox (1:0.60.2-3) testing unstable; urgency=low
  
  * Fix wc stdin handling (closes: #123387).
  * Fix wget to do just one DNS lookup (closes: #124068)

 -- Erik Andersen <andersee@debian.org>  Sun, 16 Dec 2001 22:51:03 -0700

busybox (1:0.60.2-2) unstable; urgency=low
  
  * Several small bugfixes (closes: #120353, #120369, #122638, 
  * Reworked wc.c to fix the severe efficiency problems and make it 
    smaller.  This one is mainly for the boot-floppies (closes: #120441)
  * Enable hostname (closes: #120511)

 -- Erik Andersen <andersee@debian.org>  Thu,  6 Dec 2001 00:06:33 -0700

busybox (1:0.60.2-1) unstable; urgency=low
  
  * New version released.  See Changelog for non-Debian specific details.
  * dpkg.c now uses an int for getopt (closes: #118975)
  * s390 console reboot msg is now appropriate (closes: #118859)
  * the manpage is no longer empty (closes: #117013)
  * no more .o files in the source tarball (closes: #112046)
  * the .udeb contents are exactly as Joey wants them (closes: #105352)
  * busybox ash is the default shell for the -static package,
    so it can cope with /etc/profile just fine (closes: #95745)

 -- Erik Andersen <andersee@debian.org>  Tue, 20 Nov 2001 03:41:29 -0700

busybox (1:0.60.1-8) unstable; urgency=low
  
  * Adjusted some apps for the debian installer's .udeb package.
    Enabled ifconfig, route.  
    Disabled chgrp, clear, date, dd, du, gzip, halt, head, killall,
    loadkmap, logger, mkswap, more, poweroff, reset, sleep, sort, 
    swapon, swapoff, touch, tty, uniq, uname, uptime, vi, wc, which,
    whoami, xargs, and yes.

 -- Erik Andersen <andersee@debian.org>  Thu, 18 Oct 2001 22:59:06 -0600

busybox (1:0.60.1-7) unstable; urgency=low
  
  * Re-enable wget's status bar for today's dbootstrap change. (closes: #115717)
  * Enable initrd support (even if they are a bad idea). (closes: #114727)

 -- Erik Andersen <andersee@debian.org>  Mon, 15 Oct 2001 20:45:57 -0600

busybox (1:0.60.1-6) unstable; urgency=low
  
  * Re-enable wc, gzip, tty, and expr. (closes: #114906)

 -- Erik Andersen <andersee@debian.org>  Wed, 10 Oct 2001 02:47:50 -0600

busybox (1:0.60.1-5) unstable; urgency=low
  
  * Time to make this official.  This enables several applets, such
    as ifconfig and route, and disables several others.
  * Revert ash to the version in the busybox stable branch.  For the 
    -3 non-release, I tried the one from busybox unstable (which lived 
    up to its name).  (closes: #112503)
  * Enable id, disable ash (closes: #114260, #113698)
  * Backport several bugfixes from unstable

 -- Erik Andersen <andersee@debian.org>  Fri,  5 Oct 2001 23:03:15 -0600

busybox (1:0.60.1-4) unstable; urgency=low
  
  * Doh!  With busybox ash, we need test and echo enabled...

 -- Erik Andersen <andersee@debian.org>  Wed, 26 Sep 2001 00:05:04 -0600

busybox (1:0.60.1-3) unstable; urgency=low

  * This upload is to test whether disabling several applets, and
    enabling several others will help.  Enabled is ifconfig, route,
    and ash.  Disabled is basename, date, echo, env, expr, gzip, 
    lsmod, and wc.

 -- Erik Andersen <andersee@debian.org>  Tue, 25 Sep 2001 17:45:16 -0600

busybox (1:0.60.1-2) unstable; urgency=low

  * Disabled several applets to make busybox be a bit thinner, since the 
    powerpc boot floppies are _very_ tight on space (closes: #112503)
  * Teach 'mount' about usbdevfs (closes: #111055) 
  * Busybox supports full online help, but due to space constraints on
    the boot floppies, it will not be enabled.  People can read the 
    busybox documentation if they need full details. (closes: #111350) 

 -- Erik Andersen <andersee@debian.org>  Sun, 23 Sep 2001 23:32:15 -0600

busybox (1:0.60.1-1) unstable; urgency=low

  * New stable version released.  See changelog for details.
  * Enabled 'ar' for the udeb

 -- Erik Andersen <andersee@debian.org>  Thu, 23 Aug 2001 15:44:14 -0600

busybox (1:0.60.0-1) unstable; urgency=low

  * New stable version released.  See changelog for details.

 -- Erik Andersen <andersee@debian.org>  Thu,  2 Aug 2001 12:12:37 -0600

busybox (1:0.52-1.1) unstable; urgency=high

  * Non-maintainer upload
  * Fixed wget -P handling (closes: #106223).

 -- Matt Kraai <kraai@debian.org>  Wed, 25 Jul 2001 11:01:38 -0600

busybox (1:0.52-1) unstable; urgency=high

  * New version released.  See changelog for details.

 -- Erik Andersen <andersee@debian.org>  Sat,  7 Jul 2001 01:23:45 -0600

busybox (1:0.51-10) unstable; urgency=high



=== debian/control ===
Source: busybox
Priority: optional
Maintainer: Erik Andersen <andersee@debian.org>
Build-Depends: debhelper (>= 2.1.18), dpkg-dev (>= 1.7.0)
Standards-Version: 3.2.1.0

Package: busybox
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: busybox-static
Replaces: busybox-static 
Section: utils
Description: Tiny utilities for small and embedded systems. 
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.).  The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 This package installs the BusyBox binary but does not install symlinks
 for any of the supported utilities.  You can use /bin/busybox --install
 to install BusyBox to the root directory (you do not want to do this
 to your your Debian system, except in dire emergencies!).

Package: busybox-static
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: busybox
Replaces: busybox
Section: shells
Description: Standalone rescue shell with tons of builtin utilities. 
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.).  The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 BusyBox-static provides you with a statically linked simple stand alone shell
 that provides all the utilities available in BusyBox.  This package is
 intended to be used as a rescue shell, in the event that you screw up your
 system.  Invoke "busybox sh" and you have a standalone shell ready to save
 your system from certain destruction.  Invoke "busybox", and it will list the
 available builtin commands.

Package: busybox-udeb
Architecture: any
Depends: ${shlibs:Depends}
Section: debian-installer
Priority: standard
Description: Tiny utilities for the debian-installer
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.).  The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-udeb is used by the debian-installer, so unless you are working
 on the debian-installer, this package is not for you.  Installing this 
 on your Debian system is a very, very bad idea.  You have been warned.
